﻿
using System;
using Wisej.Web;
using Wisej.Ext.ClientFileSystem;
using System.Collections.Generic;
using System.Linq;
namespace Wisej.ClientFileSystem
{
	public partial class CodeEditor : Form
	{
		string selectedFileName;
		File selectedFile = null;
		Directory directory;
		public CodeEditor()
		{
			InitializeComponent();
		}

		public CodeEditor(Directory dir, File file)
		{
			InitializeComponent();
			selectedFile = file;
			directory = dir;
		}

		private async void button1_Click(object sender, EventArgs e)
        {
			directory = await Wisej.Ext.ClientFileSystem.ClientFileSystem.ShowDirectoryPickerAsync();

			await TreeViewHelper.GetFileSystemHierarchy(directory,this.treeDirectory);
		}


        private async void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
			propertyGrid.SelectedObject = e.Node.Tag;

			if(e.Node.Tag.GetType() == typeof(File))
            {
				var file = (File)e.Node.Tag;
				aceEditor1.Text = await file.ReadTextAsync();
				selectedFile = file;
				selectedFileName = file.Name;
            }
        }

        private void pbDirectory_Click(object sender, EventArgs e)
        {
			this.directoryTreePanel.Visible = !this.directoryTreePanel.Visible;
			Wisej.Ext.ClientFileSystem.ClientFileSystem.ShowSaveFilePickerAsync(false, "", selectedFileName);
		}

        private void pbIcon_Click(object sender, EventArgs e)
        {
			new Info().ShowDialog();
        }

        private async void CodeEditor_Load(object sender, EventArgs e)
        {
			if(directory != null)
            {
				await TreeViewHelper.GetFileSystemHierarchy(directory, this.treeDirectory);
				TreeNode tn = TreeViewHelper.GetNode(selectedFile.Name, this.treeDirectory.Nodes[0]);
				AlertBox.Show(tn.ToString());
				this.treeDirectory.SelectedNode = tn;
				this.aceEditor1.Text = await selectedFile.ReadTextAsync();
			}
        }
    }
}
