﻿using System;
using Wisej.Web;
using Wisej.Ext.ClientFileSystem;
namespace Wisej.ClientFileSystem
{
    public partial class FileExplorer : Form
    {
        private Directory directory;
        public FileExplorer()
        {
            InitializeComponent();
        }

        private void FileExplorer_Load(object sender, EventArgs e)
        {
         
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            var directory = (Directory)e.Node.Tag;
            this.fillListView(directory);
            this.lblDirectoryName.Text = directory.Name;
        }

        private async void fillListView(Directory dir)
        {
            ListView lv = new ListView();
            lv.View = View.Details;

            lv.Columns.Add(new ColumnHeader() { Text = "Name", Width = 200 }) ;
            lv.Columns.Add(new ColumnHeader() { Text = "Type", Width = 100 });
            lv.Columns.Add(new ColumnHeader() { Text = "Size", Width = 100 });
            lv.Columns.Add(new ColumnHeader() { Text = "Last Modified",Width = 100 });
            lv.LargeImageList = this.imageList1;
            lv.SmallImageList = this.imageList1;
            var subDirs = await dir.GetDirectoriesAsync("");
            var files = await dir.GetFilesAsync("");

            foreach(var sd in subDirs)
            {
                lv.Items.Add(new ListViewItem() { Text = sd.Name, ImageIndex = 0, Tag = sd }) ;  
            }

            foreach (var f in files)
            {
                
                var item = new ListViewItem()
                {
                    Text = f.Name,
                    ImageIndex = 1,
                    Tag = f
                };

                string[] subItems = new string[]
                {
                    f.Type,
                    f.Size.ToString(),
                    f.LastModified.ToShortDateString(),
                };

                item.SubItems.AddRange(subItems);
                lv.Items.Add(item);
                
                
            }

            lv.Sorting = SortOrder.Ascending;
            lv.Dock = DockStyle.Fill;

            lv.ItemDoubleClick += ItemDoubleClick;
            this.panel2.Controls.Clear();
            this.panel2.Controls.Add(lv);
        }

        private void ItemDoubleClick(object sender, ItemClickEventArgs e)
        {
            var fsEntry = e.Item.Tag;
            if (fsEntry.GetType() == typeof(Directory))
            {
                this.fillListView((Directory)fsEntry);
            }
            else
            {
                File file = (File)fsEntry;
                if (file.Type.Contains("image"))
                {
                    new ImageViewer(file).Show();
                }
                else
                {
                    new CodeEditor(directory, file).Show();
                }
            }
        }

        private async void button1_Click(object sender, EventArgs e)
        {
            try
            {
                directory = await Wisej.Ext.ClientFileSystem.ClientFileSystem.ShowDirectoryPickerAsync();
                TreeViewHelper.GetFileSystemDirectoryHierarchy(directory, this.treeView1);
                this.lblDirectoryName.Visible = true;
                this.lblDirectoryName.Text = directory.Name;

                this.fillListView(directory);
            }
            catch (Exception ex)
            {
                //catch exception
            }
        }
    }
}
