﻿using System;
using Wisej.Web;
using Wisej.Ext.ClientFileSystem;

namespace Wisej.ClientFileSystem
{
    public partial class ImageViewer : Form
    {
        File imageFile = null;
        public ImageViewer()
        {
            InitializeComponent();
        }

        public ImageViewer(File imgFile)
        {
            InitializeComponent();
            imageFile = imgFile;
        }

        private void ImageViewer_Load(object sender, EventArgs e)
        {
            if (imageFile != null)
            {
                ConvertFileToPicture(imageFile);
            }
        }

        private async void ImageViewer_ToolClick(object sender, ToolClickEventArgs e)
        {
            File[] file = await Wisej.Ext.ClientFileSystem.ClientFileSystem.ShowOpenFilePickerAsync(false,false,".png");
            ConvertFileToPicture(file[0]);
        }


        private async void ConvertFileToPicture(File file)
        {
            try { 
            // Get the bytes from the imagefile
            Byte[] data = await file.ReadBytesAsync();

            //Convert byte array to stream
            System.IO.MemoryStream ms = new System.IO.MemoryStream(data);

            //Display the image in a picture box
            pictureBox1.Image = System.Drawing.Image.FromStream(ms);
            }
            catch (Exception ex)
            {
                //Catch exception
            }
        }
    }
}
